﻿namespace ExtSpec.Build
{
    /// <summary>
    /// Base class for all build services.
    /// </summary>
    public abstract class BuildServiceBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BuildServiceBase" /> class.
        /// </summary>
        /// <param name="context">The build context.</param>
        public BuildServiceBase(IBuildContext context)
        {
            this.Context = context;
        }

        /// <summary>
        /// Gets the current build context.
        /// </summary>
        /// <value>
        /// The build context.
        /// </value>
        public IBuildContext Context { get; private set; }
    }
}
