﻿namespace ExtSpec.Build
{
    /// <summary>
    /// Provides file system services.
    /// </summary>
    public interface IFileSystemProvider
    {
        /// <summary>
        /// Resets the build path prior to building.
        /// </summary>
        void ResetBuildPath();

        /// <summary>
        /// Cleans up the build path.
        /// </summary>
        void CleanupBuildPath();

        /// <summary>
        /// Rebuilds the example library directory.
        /// </summary>
        void RebuildExampleLibrary();

        /// <summary>
        /// Writes the output to the examples directory.
        /// </summary>
        void CopyOutputToExamples();
    }
}
