﻿namespace ExtSpec.Build
{
    using System;

    /// <summary>
    /// Provides process execution services.
    /// </summary>
    public interface IProcessProvider
    {
        /// <summary>
        /// Executes the specified executable using the given arguments.
        /// </summary>
        /// <param name="executable">The executable.</param>
        /// <param name="arguments">The arguments.</param>
        /// <returns>
        /// A Tuple containing an exit code and output.
        /// </returns>
        Tuple<int, string> Execute(string executable, string arguments);
    }
}
