﻿namespace ExtSpec.Build.Wrappers
{
    /// <summary>
    /// Wraps an XML Serializer.
    /// </summary>
    public interface IXmlSerializationWrapper
    {
        /// <summary>
        /// Deserializes the specified serialized string.
        /// </summary>
        /// <typeparam name="T">Any class.</typeparam>
        /// <param name="serialized">The XML serialized string.</param>
        /// <returns>
        /// An instance of T.
        /// </returns>
        T Deserialize<T>(string serialized)
            where T : class;

        /// <summary>
        /// Serializes the specified input.
        /// </summary>
        /// <typeparam name="T">Any class.</typeparam>
        /// <param name="input">The input.</param>
        /// <returns>
        /// XML serialized version of the input.
        /// </returns>
        string Serialize<T>(T input)
            where T : class;
    }
}
