﻿namespace ExtSpec.Build.Wrappers
{
    using System.IO;
    using System.Text;

    /// <summary>
    /// The ZipFile type represents a zip archive file.
    /// </summary>
    public class ZipFile : Ionic.Zip.ZipFile, IZipFile
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        public ZipFile()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        /// <param name="encoding">The Encoding is used as the default alternate encoding for entries with
        /// filenames or comments that cannot be encoded with the IBM437 code page.</param>
        /// <remarks>
        /// See the documentation on the <see cref="M:Ionic.Zip.ZipFile.#ctor(System.String)">ZipFile
        /// constructor that accepts a single string argument</see> for basic
        /// information on all the <c>ZipFile</c> constructors.
        /// </remarks>
        public ZipFile(Encoding encoding)
            : base(encoding)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        /// <param name="fileName">The filename to use for the new zip archive.</param>
        public ZipFile(string fileName)
            : base(fileName)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        /// <param name="fileName">The filename to use for the new zip archive.</param>
        /// <param name="encoding">The Encoding is used as the default alternate
        /// encoding for entries with filenames or comments that cannot be encoded
        /// with the IBM437 code page.</param>
        public ZipFile(string fileName, Encoding encoding)
            : base(fileName, encoding)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        /// <param name="fileName">The filename to use for the new zip archive.</param>
        /// <param name="statusMessageWriter">A TextWriter to use for writing
        /// verbose status messages.</param>
        public ZipFile(string fileName, TextWriter statusMessageWriter)
            : base(fileName, statusMessageWriter)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ZipFile" /> class.
        /// </summary>
        /// <param name="fileName">The filename to use for the new zip archive.</param>
        /// <param name="statusMessageWriter">A TextWriter to use for writing verbose
        /// status messages.</param>
        /// <param name="encoding">The Encoding is used as the default alternate encoding for entries with
        /// filenames or comments that cannot be encoded with the IBM437 code page.</param>
        public ZipFile(string fileName, TextWriter statusMessageWriter, Encoding encoding)
            : base(fileName, statusMessageWriter, encoding)
        {
        }
    }
}
