﻿namespace ExtSpec.Specifications.Build
{
    using ExtSpec.Build;
    using Moq;

    public abstract class BuildServiceUnitBase<T> : UnitBase<T>
        where T : BuildServiceBase
    {
        public BuildServiceUnitBase()
        {
            this.ContextMock = this.AutoMocker.Mock<IBuildContext>();

            this.ContextMock
                .SetupGet(x => x.Name)
                .Returns("EXTSPEC");

            this.ContextMock
                .SetupGet(x => x.RootPath)
                .Returns("ROOT PATH");

            this.ContextMock
                .SetupGet(x => x.BuildPath)
                .Returns("BUILD PATH");

            this.ContextMock
                .SetupGet(x => x.ExamplePath)
                .Returns("EXAMPLE PATH");

            this.ContextMock
                .SetupGet(x => x.LibraryPath)
                .Returns("LIBRARY PATH");

            this.ContextMock
                .SetupGet(x => x.ExampleZipFilePath)
                .Returns(@"EXAMPLE PATH\FILE.ZIP");

            this.ContextMock
                .SetupGet(x => x.MainZipFilePath)
                .Returns(@"BUILD PATH\FILE.ZIP");

            this.ContextMock
                .SetupGet(x => x.OutputFilePath)
                .Returns(@"BUILD PATH\EXTSPEC.JS");

            this.ContextMock
                .SetupGet(x => x.TypeScriptDefinitionFilePath)
                .Returns(@"BUILD PATH\EXTSPEC.D.TS");

            this.ContextMock
                .SetupGet(x => x.LicenseFilePath)
                .Returns(@"BUILD PATH\LICENSE.TXT");

            this.ContextMock
                .SetupGet(x => x.Version)
                .Returns("1.2.3");

            this.ContextMock
                .SetupGet(x => x.Title)
                .Returns("TITLE");

            this.ContextMock
                .SetupGet(x => x.Copyright)
                .Returns("COPYRIGHT");
        }

        public Mock<IBuildContext> ContextMock { get; private set; }
    }
}
