﻿namespace ExtSpec.Specifications.Build.Extensions
{
    using System.Reflection;
    using ExtSpec.Specifications.Expectations;
    using Xunit;

    public class AssemblyExtensionsUnit
    {
        public class GetAttributeValue
        {
            public GetAttributeValue()
            {
                this.Assembly = Assembly.GetExecutingAssembly();
            }

            public Assembly Assembly { get; set; }

            [Fact]
            public void Should_get_correct_title_from_assembly()
            {
                var actual = this.Assembly.GetAttributeValue<AssemblyTitleAttribute>(x => x.Title);

                I.Expect(actual).ToEqual("Ext Spec Specifications");
            }

            [Fact]
            public void Should_get_correct_copyright_from_assembly()
            {
                var actual = this.Assembly.GetAttributeValue<AssemblyCopyrightAttribute>(x => x.Copyright);

                I.Expect(actual).ToEqual("Copyright © Qube 2012");
            }

            [Fact]
            public void Should_return_empty_string_for_unused_attribute()
            {
                var actual = this.Assembly.GetAttributeValue<AssemblyFileVersionAttribute>(x => x.Version);

                I.Expect(actual).ToEqual(string.Empty);
            }
        }
    }
}
